VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGDIHelper"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Type GdiplusStartupInput
    GdiplusVersion As Long
    DebugEventCallback As Long
    SuppressBackgroundThread As Long
    SuppressExternalCodecs As Long
End Type

'GDI+
Private Declare Function GdipCreateBitmapFromFile Lib "gdiplus.dll" (ByVal FileName As Long, ByRef bmp As Long) As Long
Private Declare Function GdipCreateHBITMAPFromBitmap Lib "gdiplus.dll" (ByVal bmp As Long, ByRef hbmReturn As Long, ByVal background As Long) As Long
Private Declare Function GdipDisposeImage Lib "gdiplus.dll" (ByVal Image As Long) As Long
Private Declare Sub GdiplusShutdown Lib "gdiplus.dll" (ByVal Token As Long)
Private Declare Function GdiplusStartup Lib "gdiplus.dll" (ByRef Token As Long, tInput As GdiplusStartupInput, ByVal pOutput As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long


'Image list
Private Declare Function ImageList_Add Lib "COMCTL32.DLL" (ByVal himl As Long, ByVal hbmImage As Long, ByVal hbmMask As Long) As Long
Private Declare Function ImageList_Create Lib "COMCTL32.DLL" (ByVal cX As Long, ByVal cY As Long, ByVal Flags As Long, ByVal cInitial As Long, ByVal cGrow As Long) As Long
Private Declare Function ImageList_Destroy Lib "COMCTL32.DLL" (ByVal himl As Long) As Long
Private Declare Function ImageList_GetImageCount Lib "COMCTL32.DLL" (ByVal himl As Long) As Long
Private Declare Function ImageList_GetIcon Lib "COMCTL32.DLL" (ByVal himl As Long, ByVal i As Long, ByVal diFlags As Long) As Long

Private Declare Function DestroyIcon Lib "user32" (ByVal hIcon As Long) As Long


'Constants
Private Const ILC_COLOR32 = &H20
Private Const ILC_MASK = &H1


Private MyGDIPlusToken As Long
Private MyImageList As Long

Public Function GetIcon(ByVal Index As Long) As Long
38 GetIcon = ImageList_GetIcon(MyImageList, Index, 0)
End Function

Public Sub DeleteIcon(ByVal icon As Long)
42 DestroyIcon icon
End Sub

Public Property Get ImageList() As Long
46 Let ImageList = MyImageList
End Property

Public Function CreateImageListFromFiles(ByVal ListName As String) As Boolean
51 Dim objDOM As DOMDocument, objRootNode As IXMLDOMNode, objChildNode As IXMLDOMNode, intImageSize As Integer
52 Dim gdiplus As GdiplusStartupInput, strFileName As String, bitmap As Long, hBitmap As Long

'Load template
55 Set objDOM = New DOMDocument
56 If Not objDOM.Load(App.Path & "\Templates\imagelists.xml") Then
57    Set objDOM = Nothing
58    Exit Function
59 End If

'Get image size
62 Set objRootNode = objDOM.selectSingleNode("//imagelist[@id='" & ListName & "']")
63 If objRootNode Is Nothing Then
64    Set objDOM = Nothing
65    Exit Function
66 End If

'Get image size from xml
69 intImageSize = CInt(objRootNode.Attributes.getNamedItem("image_size").Text)

'Init GDI+
72 gdiplus.GdiplusVersion = 1
73 If GdiplusStartup(MyGDIPlusToken, gdiplus, 0) <> 0 Then
74    Exit Function
75 End If

'Create image list
78 If MyImageList Then
79    ImageList_Destroy MyImageList
80    MyImageList = 0
81 End If
82 MyImageList = ImageList_Create(intImageSize, intImageSize, ILC_COLOR32 Or ILC_MASK, objRootNode.childNodes.Length, 0)

'Load and add images to image list
85 For Each objChildNode In objRootNode.childNodes
86    strFileName = objChildNode.Attributes.getNamedItem("name").Text
87    If Len(Dir(App.Path & "\" & strFileName)) = 0 Then
88       strFileName = "Icons\help-icon.png"
89    End If
90    If GdipCreateBitmapFromFile(StrPtr(App.Path & "\" & strFileName), bitmap) = 0 Then
91       If GdipCreateHBITMAPFromBitmap(bitmap, hBitmap, 0) = 0 Then
92          ImageList_Add MyImageList, hBitmap, 0
93          GdipDisposeImage bitmap
94          DeleteObject hBitmap
95       End If
96    End If
97 Next

'Shut down GDI+
100 If MyGDIPlusToken Then
101    GdiplusShutdown MyGDIPlusToken
102    MyGDIPlusToken = 0
103 End If


106 CreateImageListFromFiles = True

End Function


Public Sub DestroyImageList()
186 If MyImageList Then
187    ImageList_Destroy MyImageList
188    MyImageList = 0
189 End If
End Sub
